// IWYU pragma: private, include "nvim/option_defs.h"

/// "indir" values for buffer-local options.
/// These need to be defined globally, so that the BV_COUNT can be used with
/// b_p_script_stx[].
enum {
  BV_AI = 0,
  BV_AR = 1,
  BV_BKC = 2,
  BV_BIN = 3,
  BV_BOMB = 4,
  BV_BH = 5,
  BV_BL = 6,
  BV_BT = 7,
  BV_CHANNEL = 8,
  BV_CIN = 9,
  BV_CINK = 10,
  BV_CINO = 11,
  BV_CINSD = 12,
  BV_CINW = 13,
  BV_COM = 14,
  BV_CMS = 15,
  BV_CPT = 16,
  BV_CFU = 17,
  BV_CSL = 18,
  BV_CI = 19,
  BV_DEF = 20,
  BV_DICT = 21,
  BV_EOF = 22,
  BV_EOL = 23,
  BV_EP = 24,
  BV_EFM = 25,
  BV_ET = 26,
  BV_FENC = 27,
  BV_FF = 28,
  BV_FT = 29,
  BV_FIXEOL = 30,
  BV_FEX = 31,
  BV_FLP = 32,
  BV_FO = 33,
  BV_FP = 34,
  BV_GP = 35,
  BV_IMI = 36,
  BV_IMS = 37,
  BV_INC = 38,
  BV_INEX = 39,
  BV_INDE = 40,
  BV_INDK = 41,
  BV_INF = 42,
  BV_ISK = 43,
  BV_KMAP = 44,
  BV_KP = 45,
  BV_LISP = 46,
  BV_LOP = 47,
  BV_LW = 48,
  BV_MENC = 49,
  BV_MP = 50,
  BV_MPS = 51,
  BV_ML = 52,
  BV_MA = 53,
  BV_MOD = 54,
  BV_NF = 55,
  BV_OFU = 56,
  BV_PATH = 57,
  BV_PI = 58,
  BV_QE = 59,
  BV_RO = 60,
  BV_SCBK = 61,
  BV_SW = 62,
  BV_SI = 63,
  BV_STS = 64,
  BV_SPC = 65,
  BV_SPF = 66,
  BV_SPL = 67,
  BV_SPO = 68,
  BV_SUA = 69,
  BV_SWF = 70,
  BV_SMC = 71,
  BV_SYN = 72,
  BV_TS = 73,
  BV_TC = 74,
  BV_TFU = 75,
  BV_TAGS = 76,
  BV_TW = 77,
  BV_TSR = 78,
  BV_TSRFU = 79,
  BV_UDF = 80,
  BV_UL = 81,
  BV_VSTS = 82,
  BV_VTS = 83,
  BV_WM = 84,
  BV_COUNT = 85,  ///< must be the last one
};

/// "indir" values for window-local options.
/// These need to be defined globally, so that the WV_COUNT can be used in the
/// window structure.
enum {
  WV_ARAB = 0,
  WV_BRI = 1,
  WV_BRIOPT = 2,
  WV_CC = 3,
  WV_COCU = 4,
  WV_COLE = 5,
  WV_CRBIND = 6,
  WV_CUC = 7,
  WV_CUL = 8,
  WV_CULOPT = 9,
  WV_DIFF = 10,
  WV_FCS = 11,
  WV_FDC = 12,
  WV_FEN = 13,
  WV_FDE = 14,
  WV_FDI = 15,
  WV_FDL = 16,
  WV_FMR = 17,
  WV_FDM = 18,
  WV_FML = 19,
  WV_FDN = 20,
  WV_FDT = 21,
  WV_LBR = 22,
  WV_LIST = 23,
  WV_LCS = 24,
  WV_NU = 25,
  WV_NUW = 26,
  WV_PVW = 27,
  WV_RNU = 28,
  WV_RL = 29,
  WV_RLC = 30,
  WV_SCROLL = 31,
  WV_SCBIND = 32,
  WV_SO = 33,
  WV_SBR = 34,
  WV_SISO = 35,
  WV_SCL = 36,
  WV_SMS = 37,
  WV_SPELL = 38,
  WV_STC = 39,
  WV_STL = 40,
  WV_VE = 41,
  WV_WBR = 42,
  WV_WINBL = 43,
  WV_WFB = 44,
  WV_WFH = 45,
  WV_WFW = 46,
  WV_WINHL = 47,
  WV_WRAP = 48,
  WV_COUNT = 49,  ///< must be the last one
};

typedef enum {
  kOptInvalid = -1,
  kOptAleph = 0,
  kOptAllowrevins = 1,
  kOptAmbiwidth = 2,
  kOptArabic = 3,
  kOptArabicshape = 4,
  kOptAutochdir = 5,
  kOptAutoindent = 6,
  kOptAutoread = 7,
  kOptAutowrite = 8,
  kOptAutowriteall = 9,
  kOptBackground = 10,
  kOptBackspace = 11,
  kOptBackup = 12,
  kOptBackupcopy = 13,
  kOptBackupdir = 14,
  kOptBackupext = 15,
  kOptBackupskip = 16,
  kOptBelloff = 17,
  kOptBinary = 18,
  kOptBomb = 19,
  kOptBreakat = 20,
  kOptBreakindent = 21,
  kOptBreakindentopt = 22,
  kOptBrowsedir = 23,
  kOptBufhidden = 24,
  kOptBuflisted = 25,
  kOptBuftype = 26,
  kOptCasemap = 27,
  kOptCdhome = 28,
  kOptCdpath = 29,
  kOptCedit = 30,
  kOptChannel = 31,
  kOptCharconvert = 32,
  kOptCindent = 33,
  kOptCinkeys = 34,
  kOptCinoptions = 35,
  kOptCinscopedecls = 36,
  kOptCinwords = 37,
  kOptClipboard = 38,
  kOptCmdheight = 39,
  kOptCmdwinheight = 40,
  kOptColorcolumn = 41,
  kOptColumns = 42,
  kOptComments = 43,
  kOptCommentstring = 44,
  kOptCompatible = 45,
  kOptComplete = 46,
  kOptCompletefunc = 47,
  kOptCompleteopt = 48,
  kOptCompleteslash = 49,
  kOptConcealcursor = 50,
  kOptConceallevel = 51,
  kOptConfirm = 52,
  kOptCopyindent = 53,
  kOptCpoptions = 54,
  kOptCursorbind = 55,
  kOptCursorcolumn = 56,
  kOptCursorline = 57,
  kOptCursorlineopt = 58,
  kOptDebug = 59,
  kOptDefine = 60,
  kOptDelcombine = 61,
  kOptDictionary = 62,
  kOptDiff = 63,
  kOptDiffexpr = 64,
  kOptDiffopt = 65,
  kOptDigraph = 66,
  kOptDirectory = 67,
  kOptDisplay = 68,
  kOptEadirection = 69,
  kOptEdcompatible = 70,
  kOptEmoji = 71,
  kOptEncoding = 72,
  kOptEndoffile = 73,
  kOptEndofline = 74,
  kOptEqualalways = 75,
  kOptEqualprg = 76,
  kOptErrorbells = 77,
  kOptErrorfile = 78,
  kOptErrorformat = 79,
  kOptEventignore = 80,
  kOptExpandtab = 81,
  kOptExrc = 82,
  kOptFileencoding = 83,
  kOptFileencodings = 84,
  kOptFileformat = 85,
  kOptFileformats = 86,
  kOptFileignorecase = 87,
  kOptFiletype = 88,
  kOptFillchars = 89,
  kOptFixendofline = 90,
  kOptFoldclose = 91,
  kOptFoldcolumn = 92,
  kOptFoldenable = 93,
  kOptFoldexpr = 94,
  kOptFoldignore = 95,
  kOptFoldlevel = 96,
  kOptFoldlevelstart = 97,
  kOptFoldmarker = 98,
  kOptFoldmethod = 99,
  kOptFoldminlines = 100,
  kOptFoldnestmax = 101,
  kOptFoldopen = 102,
  kOptFoldtext = 103,
  kOptFormatexpr = 104,
  kOptFormatlistpat = 105,
  kOptFormatoptions = 106,
  kOptFormatprg = 107,
  kOptFsync = 108,
  kOptGdefault = 109,
  kOptGrepformat = 110,
  kOptGrepprg = 111,
  kOptGuicursor = 112,
  kOptGuifont = 113,
  kOptGuifontwide = 114,
  kOptGuioptions = 115,
  kOptGuitablabel = 116,
  kOptGuitabtooltip = 117,
  kOptHelpfile = 118,
  kOptHelpheight = 119,
  kOptHelplang = 120,
  kOptHidden = 121,
  kOptHighlight = 122,
  kOptHistory = 123,
  kOptHkmap = 124,
  kOptHkmapp = 125,
  kOptHlsearch = 126,
  kOptIcon = 127,
  kOptIconstring = 128,
  kOptIgnorecase = 129,
  kOptImcmdline = 130,
  kOptImdisable = 131,
  kOptIminsert = 132,
  kOptImsearch = 133,
  kOptInccommand = 134,
  kOptInclude = 135,
  kOptIncludeexpr = 136,
  kOptIncsearch = 137,
  kOptIndentexpr = 138,
  kOptIndentkeys = 139,
  kOptInfercase = 140,
  kOptInsertmode = 141,
  kOptIsfname = 142,
  kOptIsident = 143,
  kOptIskeyword = 144,
  kOptIsprint = 145,
  kOptJoinspaces = 146,
  kOptJumpoptions = 147,
  kOptKeymap = 148,
  kOptKeymodel = 149,
  kOptKeywordprg = 150,
  kOptLangmap = 151,
  kOptLangmenu = 152,
  kOptLangnoremap = 153,
  kOptLangremap = 154,
  kOptLaststatus = 155,
  kOptLazyredraw = 156,
  kOptLinebreak = 157,
  kOptLines = 158,
  kOptLinespace = 159,
  kOptLisp = 160,
  kOptLispoptions = 161,
  kOptLispwords = 162,
  kOptList = 163,
  kOptListchars = 164,
  kOptLoadplugins = 165,
  kOptMagic = 166,
  kOptMakeef = 167,
  kOptMakeencoding = 168,
  kOptMakeprg = 169,
  kOptMatchpairs = 170,
  kOptMatchtime = 171,
  kOptMaxcombine = 172,
  kOptMaxfuncdepth = 173,
  kOptMaxmapdepth = 174,
  kOptMaxmempattern = 175,
  kOptMenuitems = 176,
  kOptMkspellmem = 177,
  kOptModeline = 178,
  kOptModelineexpr = 179,
  kOptModelines = 180,
  kOptModifiable = 181,
  kOptModified = 182,
  kOptMore = 183,
  kOptMouse = 184,
  kOptMousefocus = 185,
  kOptMousehide = 186,
  kOptMousemodel = 187,
  kOptMousemoveevent = 188,
  kOptMousescroll = 189,
  kOptMouseshape = 190,
  kOptMousetime = 191,
  kOptNrformats = 192,
  kOptNumber = 193,
  kOptNumberwidth = 194,
  kOptOmnifunc = 195,
  kOptOpendevice = 196,
  kOptOperatorfunc = 197,
  kOptPackpath = 198,
  kOptParagraphs = 199,
  kOptPaste = 200,
  kOptPastetoggle = 201,
  kOptPatchexpr = 202,
  kOptPatchmode = 203,
  kOptPath = 204,
  kOptPreserveindent = 205,
  kOptPreviewheight = 206,
  kOptPreviewwindow = 207,
  kOptPrompt = 208,
  kOptPumblend = 209,
  kOptPumheight = 210,
  kOptPumwidth = 211,
  kOptPyxversion = 212,
  kOptQuickfixtextfunc = 213,
  kOptQuoteescape = 214,
  kOptReadonly = 215,
  kOptRedrawdebug = 216,
  kOptRedrawtime = 217,
  kOptRegexpengine = 218,
  kOptRelativenumber = 219,
  kOptRemap = 220,
  kOptReport = 221,
  kOptRevins = 222,
  kOptRightleft = 223,
  kOptRightleftcmd = 224,
  kOptRuler = 225,
  kOptRulerformat = 226,
  kOptRuntimepath = 227,
  kOptScroll = 228,
  kOptScrollback = 229,
  kOptScrollbind = 230,
  kOptScrolljump = 231,
  kOptScrolloff = 232,
  kOptScrollopt = 233,
  kOptSections = 234,
  kOptSecure = 235,
  kOptSelection = 236,
  kOptSelectmode = 237,
  kOptSessionoptions = 238,
  kOptShada = 239,
  kOptShadafile = 240,
  kOptShell = 241,
  kOptShellcmdflag = 242,
  kOptShellpipe = 243,
  kOptShellquote = 244,
  kOptShellredir = 245,
  kOptShellslash = 246,
  kOptShelltemp = 247,
  kOptShellxescape = 248,
  kOptShellxquote = 249,
  kOptShiftround = 250,
  kOptShiftwidth = 251,
  kOptShortmess = 252,
  kOptShowbreak = 253,
  kOptShowcmd = 254,
  kOptShowcmdloc = 255,
  kOptShowfulltag = 256,
  kOptShowmatch = 257,
  kOptShowmode = 258,
  kOptShowtabline = 259,
  kOptSidescroll = 260,
  kOptSidescrolloff = 261,
  kOptSigncolumn = 262,
  kOptSmartcase = 263,
  kOptSmartindent = 264,
  kOptSmarttab = 265,
  kOptSmoothscroll = 266,
  kOptSofttabstop = 267,
  kOptSpell = 268,
  kOptSpellcapcheck = 269,
  kOptSpellfile = 270,
  kOptSpelllang = 271,
  kOptSpelloptions = 272,
  kOptSpellsuggest = 273,
  kOptSplitbelow = 274,
  kOptSplitkeep = 275,
  kOptSplitright = 276,
  kOptStartofline = 277,
  kOptStatuscolumn = 278,
  kOptStatusline = 279,
  kOptSuffixes = 280,
  kOptSuffixesadd = 281,
  kOptSwapfile = 282,
  kOptSwitchbuf = 283,
  kOptSynmaxcol = 284,
  kOptSyntax = 285,
  kOptTabline = 286,
  kOptTabpagemax = 287,
  kOptTabstop = 288,
  kOptTagbsearch = 289,
  kOptTagcase = 290,
  kOptTagfunc = 291,
  kOptTaglength = 292,
  kOptTagrelative = 293,
  kOptTags = 294,
  kOptTagstack = 295,
  kOptTermbidi = 296,
  kOptTermencoding = 297,
  kOptTermguicolors = 298,
  kOptTermpastefilter = 299,
  kOptTermsync = 300,
  kOptTerse = 301,
  kOptTextwidth = 302,
  kOptThesaurus = 303,
  kOptThesaurusfunc = 304,
  kOptTildeop = 305,
  kOptTimeout = 306,
  kOptTimeoutlen = 307,
  kOptTitle = 308,
  kOptTitlelen = 309,
  kOptTitleold = 310,
  kOptTitlestring = 311,
  kOptTtimeout = 312,
  kOptTtimeoutlen = 313,
  kOptTtyfast = 314,
  kOptUndodir = 315,
  kOptUndofile = 316,
  kOptUndolevels = 317,
  kOptUndoreload = 318,
  kOptUpdatecount = 319,
  kOptUpdatetime = 320,
  kOptVarsofttabstop = 321,
  kOptVartabstop = 322,
  kOptVerbose = 323,
  kOptVerbosefile = 324,
  kOptViewdir = 325,
  kOptViewoptions = 326,
  kOptVirtualedit = 327,
  kOptVisualbell = 328,
  kOptWarn = 329,
  kOptWhichwrap = 330,
  kOptWildchar = 331,
  kOptWildcharm = 332,
  kOptWildignore = 333,
  kOptWildignorecase = 334,
  kOptWildmenu = 335,
  kOptWildmode = 336,
  kOptWildoptions = 337,
  kOptWinaltkeys = 338,
  kOptWinbar = 339,
  kOptWinblend = 340,
  kOptWindow = 341,
  kOptWinfixbuf = 342,
  kOptWinfixheight = 343,
  kOptWinfixwidth = 344,
  kOptWinheight = 345,
  kOptWinhighlight = 346,
  kOptWinminheight = 347,
  kOptWinminwidth = 348,
  kOptWinwidth = 349,
  kOptWrap = 350,
  kOptWrapmargin = 351,
  kOptWrapscan = 352,
  kOptWrite = 353,
  kOptWriteany = 354,
  kOptWritebackup = 355,
  kOptWritedelay = 356,
  // Option count, used when iterating through options
#define kOptIndexCount 357
} OptIndex;

